import { CKBNode } from './interface';
import { Address, CellDep, DepType, Indexer, RPC, config } from '@ckb-lumos/lumos';
import type { DeployOptions, InfraScript } from './types';
export declare abstract class CKBNodeBase implements CKBNode {
    abstract start(params: any): void;
    abstract stop(params: any): void;
    abstract get url(): string;
    abstract get port(): string;
    abstract get host(): string;
    abstract get lumosConfig(): config.Config;
    protected abstract set lumosConfig(config: config.Config);
    protected doDeploy(rpc: RPC, indexer: Indexer, from: Address, privateKey: string, script: string, filePath: string, cellDeps?: {
        name: string;
        cellDep: CellDep;
    }[], depType?: DepType): Promise<InfraScript>;
    protected deployBuiltInScripts(scriptName: string[], builtInDirPath: string, indexer: Indexer, rpc: RPC, from: Address, privateKey: string): Promise<InfraScript[]>;
    private sign;
    protected deployCustomScripts(filePath: string, indexer: Indexer, rpc: RPC, from: Address, privateKey: string): Promise<InfraScript[]>;
    deployScripts({ builtInScriptName, configFilePath, builtInDirPath, indexer, rpc, privateKey, }: DeployOptions): Promise<void>;
    generateLumosConfig(): Promise<void>;
}
//# sourceMappingURL=base.d.ts.map