"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _CKBBinNetwork_instances, _CKBBinNetwork_port, _CKBBinNetwork_host, _CKBBinNetwork_lumosConfig, _CKBBinNetwork_initConfig, _CKBBinNetwork_startNode, _CKBBinNetwork_osPlatform, _CKBBinNetwork_packageType, _CKBBinNetwork_download;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CKBBinNetwork = void 0;
const lumos_1 = require("@ckb-lumos/lumos");
const child_process_1 = require("child_process");
const helper_1 = require("./helper");
const fs_1 = __importDefault(require("fs"));
const node_path_1 = __importDefault(require("node:path"));
const base_1 = require("./base");
const kuai_common_1 = require("@ckb-js/kuai-common");
const node_os_1 = __importDefault(require("node:os"));
class CKBBinNetwork extends base_1.CKBNodeBase {
    constructor() {
        super(...arguments);
        _CKBBinNetwork_instances.add(this);
        _CKBBinNetwork_port.set(this, '8114');
        _CKBBinNetwork_host.set(this, '127.0.0.1');
        _CKBBinNetwork_lumosConfig.set(this, lumos_1.config.getConfig());
        _CKBBinNetwork_osPlatform.set(this, () => {
            switch (node_os_1.default.platform()) {
                case 'darwin':
                    return 'apple-darwin';
                case 'linux':
                    return 'unknown-linux-gnu';
                case 'win32':
                    return 'pc-windows-msvc';
            }
        });
        _CKBBinNetwork_packageType.set(this, () => {
            switch (node_os_1.default.platform()) {
                case 'darwin':
                case 'win32':
                    return 'zip';
                case 'linux':
                    return 'tar.gz';
            }
        });
    }
    stop({ version, clear }) {
        const ckbPath = (0, kuai_common_1.cachePath)('ckb', 'bin', `ckb_${version}_${node_os_1.default.machine()}-${__classPrivateFieldGet(this, _CKBBinNetwork_osPlatform, "f").call(this)}`);
        if (fs_1.default.existsSync(node_path_1.default.resolve(ckbPath, 'pid'))) {
            const indexer = fs_1.default.readFileSync(node_path_1.default.resolve(ckbPath, 'pid', 'indexer'), 'utf-8');
            (0, child_process_1.spawn)('kill', ['-15', indexer]);
            const miner = fs_1.default.readFileSync(node_path_1.default.resolve(ckbPath, 'pid', 'miner'), 'utf-8');
            (0, child_process_1.spawn)('kill', ['-15', miner]);
        }
        if (clear) {
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'ckb-miner.toml'));
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'ckb.toml'));
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'data'), { recursive: true, force: true });
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'default.db-options'));
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'specs'), { recursive: true, force: true });
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'pid'), { recursive: true, force: true });
            fs_1.default.rmSync(node_path_1.default.resolve(ckbPath, 'dev.toml'));
        }
    }
    async start({ detached = true, genesisAccountArgs, port, version }) {
        __classPrivateFieldSet(this, _CKBBinNetwork_port, port, "f");
        const { ckbPath } = await __classPrivateFieldGet(this, _CKBBinNetwork_instances, "m", _CKBBinNetwork_download).call(this, version);
        __classPrivateFieldGet(this, _CKBBinNetwork_instances, "m", _CKBBinNetwork_initConfig).call(this, ckbPath, genesisAccountArgs);
        __classPrivateFieldGet(this, _CKBBinNetwork_instances, "m", _CKBBinNetwork_startNode).call(this, ckbPath, detached, 'indexer');
        __classPrivateFieldGet(this, _CKBBinNetwork_instances, "m", _CKBBinNetwork_startNode).call(this, ckbPath, detached, 'miner');
    }
    get url() {
        return `http://${__classPrivateFieldGet(this, _CKBBinNetwork_host, "f")}:${__classPrivateFieldGet(this, _CKBBinNetwork_port, "f")}`;
    }
    get port() {
        return __classPrivateFieldGet(this, _CKBBinNetwork_port, "f");
    }
    get host() {
        return __classPrivateFieldGet(this, _CKBBinNetwork_host, "f");
    }
    get lumosConfig() {
        return __classPrivateFieldGet(this, _CKBBinNetwork_lumosConfig, "f");
    }
    set lumosConfig(config) {
        __classPrivateFieldSet(this, _CKBBinNetwork_lumosConfig, config, "f");
    }
}
exports.CKBBinNetwork = CKBBinNetwork;
_CKBBinNetwork_port = new WeakMap(), _CKBBinNetwork_host = new WeakMap(), _CKBBinNetwork_lumosConfig = new WeakMap(), _CKBBinNetwork_osPlatform = new WeakMap(), _CKBBinNetwork_packageType = new WeakMap(), _CKBBinNetwork_instances = new WeakSet(), _CKBBinNetwork_initConfig = function _CKBBinNetwork_initConfig(ckbPath, genesisAccountArgs) {
    const devConfig = (0, helper_1.generateDevConfig)(genesisAccountArgs);
    fs_1.default.writeFileSync(node_path_1.default.resolve(ckbPath, 'dev.toml'), devConfig, { flag: 'w' });
    if (!fs_1.default.existsSync(node_path_1.default.resolve(ckbPath, 'ckb.toml'))) {
        const out = (0, child_process_1.execSync)(`${node_path_1.default.resolve(ckbPath, 'ckb')} init -C ${ckbPath} --chain dev --import-spec ${node_path_1.default.resolve(ckbPath, 'dev.toml')} --ba-arg 0x839f6f4d6fdf773d3e015f8b19fe5c4ccb07723d --ba-code-hash 0x9bd7e06f3ecf4be0f2fcd2188b23f1b9fcc88e5d4b65a8637b17723bbda3cce8 --ba-hash-type type --ba-message 0x1234`);
        console.info(out.toString());
        fs_1.default.copyFileSync(node_path_1.default.resolve(__dirname, '../ckb/ckb-miner.toml'), node_path_1.default.join(ckbPath, 'ckb-miner.toml'));
    }
    if (!fs_1.default.existsSync(node_path_1.default.join(ckbPath, 'pid'))) {
        fs_1.default.mkdirSync(node_path_1.default.join(ckbPath, 'pid'));
    }
}, _CKBBinNetwork_startNode = async function _CKBBinNetwork_startNode(ckbPath, detached, nodeType) {
    var _a, _b;
    const child = (() => {
        switch (nodeType) {
            case 'indexer':
                return (0, child_process_1.spawn)(node_path_1.default.resolve(ckbPath, 'ckb'), ['run', '-C', ckbPath, '--indexer'], {
                    detached,
                });
            case 'miner':
                return (0, child_process_1.spawn)(node_path_1.default.resolve(ckbPath, 'ckb'), ['miner', '-C', ckbPath], {
                    detached,
                });
        }
    })();
    if (child.pid) {
        fs_1.default.writeFileSync(node_path_1.default.resolve(ckbPath, 'pid', nodeType), child.pid.toString(), {
            flag: 'w',
            encoding: 'utf-8',
        });
    }
    (_a = child.stdout) === null || _a === void 0 ? void 0 : _a.on('data', (data) => {
        console.info(data.toString());
    });
    (_b = child.stderr) === null || _b === void 0 ? void 0 : _b.on('data', (data) => {
        console.info(data.toString());
    });
    if (detached) {
        child.unref();
    }
}, _CKBBinNetwork_download = async function _CKBBinNetwork_download(version) {
    const binPath = (0, kuai_common_1.cachePath)('ckb', 'bin');
    const zipPath = (0, kuai_common_1.cachePath)('ckb', 'zip');
    const packageName = `ckb_${version}_${node_os_1.default.machine()}-${__classPrivateFieldGet(this, _CKBBinNetwork_osPlatform, "f").call(this)}`;
    const packageFileName = `${packageName}.${__classPrivateFieldGet(this, _CKBBinNetwork_packageType, "f").call(this)}`;
    const ckbPath = node_path_1.default.join(binPath, packageName);
    const packagePath = node_path_1.default.resolve(zipPath, `${packageFileName}`);
    if (!fs_1.default.existsSync(ckbPath)) {
        if (!fs_1.default.existsSync(packagePath)) {
            await (0, kuai_common_1.downloadFile)(`https://github.com/nervosnetwork/ckb/releases/download/${version}/${packageFileName}`, packagePath);
        }
        if (__classPrivateFieldGet(this, _CKBBinNetwork_osPlatform, "f").call(this) === 'unknown-linux-gnu') {
            (0, child_process_1.execSync)(`tar -xf ${node_path_1.default.resolve(zipPath, `${packageFileName}`)} -C ${binPath}`);
        }
        else {
            (0, child_process_1.execSync)(`unzip ${node_path_1.default.resolve(zipPath, `${packageFileName}`)} -d ${binPath}`);
        }
    }
    return { ckbPath: node_path_1.default.join(binPath, packageName) };
};
