"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _CkbDockerNetwork_docker, _CkbDockerNetwork_lumosConfig, _CkbDockerNetwork_port, _CkbDockerNetwork_host;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CkbDockerNetwork = void 0;
const dockerode_1 = __importDefault(require("dockerode"));
const node_path_1 = require("node:path");
const node_fs_1 = __importDefault(require("node:fs"));
const lumos_1 = require("@ckb-lumos/lumos");
const helper_1 = require("./helper");
const base_1 = require("./base");
const CKB_NODE_IMAGE = 'kuai/ckb-dev';
const DOCKER_SOCKET_PATH = process.env.DOCKER_SOCKET || '/var/run/docker.sock';
class CkbDockerNetwork extends base_1.CKBNodeBase {
    constructor() {
        super();
        _CkbDockerNetwork_docker.set(this, void 0);
        _CkbDockerNetwork_lumosConfig.set(this, lumos_1.config.getConfig());
        _CkbDockerNetwork_port.set(this, '8114');
        _CkbDockerNetwork_host.set(this, 'localhost');
        __classPrivateFieldSet(this, _CkbDockerNetwork_docker, new dockerode_1.default({ socketPath: DOCKER_SOCKET_PATH }), "f");
    }
    async start({ port, detached = false, genesisAccountArgs = [] }) {
        __classPrivateFieldSet(this, _CkbDockerNetwork_port, port, "f");
        const devConfig = (0, helper_1.generateDevConfig)(genesisAccountArgs);
        node_fs_1.default.writeFileSync((0, node_path_1.join)(__dirname, '../ckb', 'dev.toml'), devConfig);
        const config = {
            HostConfig: {
                AutoRemove: true,
                PortBindings: { '8114/tcp': [{ HostPort: __classPrivateFieldGet(this, _CkbDockerNetwork_port, "f") }] },
            },
        };
        const buildStream = await __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").buildImage({
            context: (0, node_path_1.join)(__dirname, '../ckb'),
            src: ['Dockerfile', 'dev.toml', 'ckb-miner.toml', 'entrypoint.sh'],
        }, { t: CKB_NODE_IMAGE });
        await new Promise((resolve, reject) => {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").modem.followProgress(buildStream, (err, res) => (err ? reject(err) : resolve(res)));
        });
        if (!detached) {
            return __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").run(CKB_NODE_IMAGE, [], process.stdout, config);
        }
        const container = await __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").createContainer({
            Image: CKB_NODE_IMAGE,
            Tty: false,
            ...config,
        });
        return container.start();
    }
    async stop() {
        const containers = await __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").listContainers();
        await Promise.all(containers
            .filter((container) => container.Image === CKB_NODE_IMAGE)
            .map((container) => __classPrivateFieldGet(this, _CkbDockerNetwork_docker, "f").getContainer(container.Id).stop()));
    }
    get lumosConfig() {
        return __classPrivateFieldGet(this, _CkbDockerNetwork_lumosConfig, "f");
    }
    set lumosConfig(config) {
        __classPrivateFieldSet(this, _CkbDockerNetwork_lumosConfig, config, "f");
    }
    get url() {
        return `http://${__classPrivateFieldGet(this, _CkbDockerNetwork_host, "f")}:${__classPrivateFieldGet(this, _CkbDockerNetwork_port, "f")}`;
    }
    get host() {
        return __classPrivateFieldGet(this, _CkbDockerNetwork_host, "f");
    }
    get port() {
        return __classPrivateFieldGet(this, _CkbDockerNetwork_port, "f");
    }
}
exports.CkbDockerNetwork = CkbDockerNetwork;
_CkbDockerNetwork_docker = new WeakMap(), _CkbDockerNetwork_lumosConfig = new WeakMap(), _CkbDockerNetwork_port = new WeakMap(), _CkbDockerNetwork_host = new WeakMap();
