"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CKBLatestBinVersion = exports.generateDevConfig = void 0;
const fs_1 = __importDefault(require("fs"));
const node_path_1 = require("node:path");
const undici_1 = require("undici");
const generateDevConfig = (genesisAccountArgs = []) => {
    const generateGenesisAccount = (args) => `
[[genesis.issued_cells]]
capacity = 20_000_000_000_00000000
lock.code_hash = "0x9bd7e06f3ecf4be0f2fcd2188b23f1b9fcc88e5d4b65a8637b17723bbda3cce8"
lock.args = "${args}"
lock.hash_type = "type"\n`;
    const extraConfig = genesisAccountArgs.reduce((a, b) => a + generateGenesisAccount(b), '');
    const config = fs_1.default.readFileSync((0, node_path_1.join)(__dirname, '../ckb', 'dev-template.toml'), 'utf-8');
    return config + extraConfig;
};
exports.generateDevConfig = generateDevConfig;
const CKBLatestBinVersion = async () => {
    const { body } = await (0, undici_1.request)('https://api.github.com/repos/nervosnetwork/ckb/releases/latest', {
        method: 'GET',
        // Here is why we need to set a custom User-Agent:
        // https://docs.github.com/en/rest/overview/resources-in-the-rest-api?apiVersion=2022-11-28#user-agent-required
        headers: { Accept: 'application/vnd.github+json', 'User-Agent': 'CKB-Js-Kuai-DApp' },
    });
    const json = await body.json();
    return json.tag_name;
};
exports.CKBLatestBinVersion = CKBLatestBinVersion;
